> This page is for API Reference.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.navipartner.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.navipartner.com/_mcp/server.

# Webhook Integration Guide

Webhooks allow your application to receive real-time event notifications from our system. Instead of polling for updates, you can configure a URL endpoint where we will send event payloads as POST requests.

You can explore available webhooks in this portal.

## Quick Start

#### 1. Create a webhook subscription

Subscribe to an event you chose:

### Request

POST [https://api.npretail.app/\{tenant}/\{environment}/\{company}/webhook](https://api.npretail.app/\{tenant}/\{environment}/\{company}/webhook)

```curl
curl -X POST https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./webhook \
     -H "x-np-api-key: <NaviPartner API Key>" \
     -H "Content-Type: application/json" \
     -d '{
  "notificationUrl": "https://webhook.site/7bb075d4-62ff-4bd9-8832-502c9ed94ab7",
  "eventName": "pos_sale_completed",
  "clientState": "HVA0Y6B84KBNISG45W6CA4TNE38CHSBASD"
}'
```

```python
import requests

url = "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./webhook"

payload = {
    "notificationUrl": "https://webhook.site/7bb075d4-62ff-4bd9-8832-502c9ed94ab7",
    "eventName": "pos_sale_completed",
    "clientState": "HVA0Y6B84KBNISG45W6CA4TNE38CHSBASD"
}
headers = {
    "x-np-api-key": "<NaviPartner API Key>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./webhook';
const options = {
  method: 'POST',
  headers: {'x-np-api-key': '<NaviPartner API Key>', 'Content-Type': 'application/json'},
  body: '{"notificationUrl":"https://webhook.site/7bb075d4-62ff-4bd9-8832-502c9ed94ab7","eventName":"pos_sale_completed","clientState":"HVA0Y6B84KBNISG45W6CA4TNE38CHSBASD"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./webhook"

	payload := strings.NewReader("{\n  \"notificationUrl\": \"https://webhook.site/7bb075d4-62ff-4bd9-8832-502c9ed94ab7\",\n  \"eventName\": \"pos_sale_completed\",\n  \"clientState\": \"HVA0Y6B84KBNISG45W6CA4TNE38CHSBASD\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-np-api-key", "<NaviPartner API Key>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./webhook")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-np-api-key"] = '<NaviPartner API Key>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"notificationUrl\": \"https://webhook.site/7bb075d4-62ff-4bd9-8832-502c9ed94ab7\",\n  \"eventName\": \"pos_sale_completed\",\n  \"clientState\": \"HVA0Y6B84KBNISG45W6CA4TNE38CHSBASD\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./webhook")
  .header("x-np-api-key", "<NaviPartner API Key>")
  .header("Content-Type", "application/json")
  .body("{\n  \"notificationUrl\": \"https://webhook.site/7bb075d4-62ff-4bd9-8832-502c9ed94ab7\",\n  \"eventName\": \"pos_sale_completed\",\n  \"clientState\": \"HVA0Y6B84KBNISG45W6CA4TNE38CHSBASD\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./webhook', [
  'body' => '{
  "notificationUrl": "https://webhook.site/7bb075d4-62ff-4bd9-8832-502c9ed94ab7",
  "eventName": "pos_sale_completed",
  "clientState": "HVA0Y6B84KBNISG45W6CA4TNE38CHSBASD"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-np-api-key' => '<NaviPartner API Key>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./webhook");
var request = new RestRequest(Method.POST);
request.AddHeader("x-np-api-key", "<NaviPartner API Key>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"notificationUrl\": \"https://webhook.site/7bb075d4-62ff-4bd9-8832-502c9ed94ab7\",\n  \"eventName\": \"pos_sale_completed\",\n  \"clientState\": \"HVA0Y6B84KBNISG45W6CA4TNE38CHSBASD\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "x-np-api-key": "<NaviPartner API Key>",
  "Content-Type": "application/json"
]
let parameters = [
  "notificationUrl": "https://webhook.site/7bb075d4-62ff-4bd9-8832-502c9ed94ab7",
  "eventName": "pos_sale_completed",
  "clientState": "HVA0Y6B84KBNISG45W6CA4TNE38CHSBASD"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./webhook")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

#### 2. Webhook notifications

When a webhooks is triggered, you'll receive a POST request. Notice that the individual webhook events are inside an array, as they might be batched together in practice:

```json
{
  "value": [
    {
      "appId": "992c2309-cca4-43cb-9e41-911f482ec088",
      "clientState": "HVA0Y6B84KBNISG45W6CA4TNE38CHSBASD",
      "eventName": "pos_sale_completed",
      "eventVersion": "1.0",
      "timestamp": "2024-01-15T10:30:00Z",
      "companyName": "CRONUS International Ltd.",
      "payload": {
        "saleId": "e20d09ad-ab74-4f31-912f-ea58d3c9e653",
        "posUnit": "POS-031",
        "receiptNo": "D12345678",
        "fiscalDocumentNo": "FS12345678",
        "customerNo": "C12345678"
      }
    }
  ]
}
```

#### 3. Webhook subscription management

| Action                         | Endpoint               |
| ------------------------------ | ---------------------- |
| List all webhook subscriptions | `GET /webhook`         |
| Get a webhook subscription     | `GET /webhook/{id}`    |
| Create a webhook subscription  | `POST /webhook`        |
| Delete a webhook subscription  | `DELETE /webhook/{id}` |

For complete webhook endpoint references, navigate  [here](api-reference/system-services/webhooks).